{% for f in items %}
{{ f.identifier | md_style(bold=True) | MkHeader }}
{{ (f.identifier ~ f.filter_fn | format_signature) | md_style(code=True) }}
{% for k, v in f.examples.items() %}

{{ f.filter_fn | get_doc(only_summary=True) }}

{% if f.aliases %}
**Aliases:** {% for alias in f.aliases %} `{{ alias }}` {% endfor %}
{% endif %}
{% if f.required_packages %}
**Required packages:** {% for required_package in f.required_packages %} `{{ required_package}}` {% endfor %}
{% endif %}

!!! jinja "Example"
    Jinja call:
    {{ v.template | MkCode(language="jinja") | string | indent }}

    Result:

    {{ v.template | render_string | MkCode(language="") | string | indent }}


{{ f.filter_fn | MkDocStrings(show_docstring_description=False, heading_level=4) | MkAdmonition(collapsible=True, title="DocStrings") }}


{% endfor %}
{% endfor %}
